Index: trunk/sources/HeuristicLab.CEDMA.Core/3.3/Console.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/3.3/Console.cs	(revision 2146)
+++ trunk/sources/HeuristicLab.CEDMA.Core/3.3/Console.cs	(revision 2223)
@@ -28,21 +28,21 @@
 using System.ServiceModel;
 using System.ServiceModel.Description;
-using HeuristicLab.CEDMA.DB.Interfaces;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Modeling.Database.SQLServerCompact;
 
 namespace HeuristicLab.CEDMA.Core {
   public class Console : ItemBase, IEditable {
-    private string serverUri;
-    public string ServerUri {
-      get { return serverUri; }
+    private static readonly string sqlServerCompactFile = AppDomain.CurrentDomain.BaseDirectory + "HeuristicLab.Modeling.database.sdf";
+    private static readonly string sqlServerCompactConnectionString = @"Data Source=" + sqlServerCompactFile;
+
+    private Results results;
+    public Results Results {
+      get {
+        if (results == null) ReloadResults();
+        return results;
+      }
     }
-
-    private DataSet dataSet;
-    public DataSet DataSet {
-      get { return dataSet; }
-    }
-
     public Console()
       : base() {
-      dataSet = new DataSet();
     }
 
@@ -55,27 +55,6 @@
     }
 
-    #region serialization
-    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
-      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
-      XmlAttribute uriAttribute = document.CreateAttribute("ServerURI");
-      uriAttribute.Value = serverUri;
-      node.Attributes.Append(uriAttribute);
-      return node;
-    }
-
-    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
-      base.Populate(node, restoredObjects);
-      serverUri = node.Attributes["ServerURI"].Value;
-    }
-    #endregion
-
-    internal void Connect(string serverUri) {
-      IStore store = new StoreProxy(serverUri);
-      var variableBindings = store.Query("?Dataset <" + Ontology.InstanceOf + "> <" + Ontology.TypeDataSet + "> .", 0, 10).ToArray();
-      if (variableBindings.Length > 0) {
-        dataSet = new DataSet(store, (Entity)variableBindings[0].Get("Dataset"));
-      } else {
-        dataSet.Store = store;
-      }
+    private void ReloadResults() {
+      results = new Results(new DatabaseService(sqlServerCompactConnectionString));
     }
   }
Index: trunk/sources/HeuristicLab.CEDMA.Core/3.3/ConsoleEditor.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/3.3/ConsoleEditor.cs	(revision 2146)
+++ trunk/sources/HeuristicLab.CEDMA.Core/3.3/ConsoleEditor.cs	(revision 2223)
@@ -29,12 +29,9 @@
 using HeuristicLab.PluginInfrastructure;
 using System.Drawing;
-using HeuristicLab.CEDMA.DB.Interfaces;
 
 namespace HeuristicLab.CEDMA.Core {
   class ConsoleEditor : EditorBase {
-    private System.Windows.Forms.TextBox uriTextBox;
-    private System.Windows.Forms.Label uriLabel;
-    private Button connectButton;
-    private Panel serverPanel;
+    private ComboBox viewComboBox;
+    private Button resultsButton;
     private Console console;
 
@@ -42,61 +39,41 @@
       InitializeComponent();
       this.console = console;
+      PopulateViewComboBox();
     }
 
     #region autogenerated code
     private void InitializeComponent() {
-      this.uriTextBox = new System.Windows.Forms.TextBox();
-      this.uriLabel = new System.Windows.Forms.Label();
-      this.connectButton = new System.Windows.Forms.Button();
-      this.serverPanel = new System.Windows.Forms.Panel();
+      this.viewComboBox = new System.Windows.Forms.ComboBox();
+      this.resultsButton = new System.Windows.Forms.Button();
       this.SuspendLayout();
       // 
-      // uriTextBox
+      // viewComboBox
       // 
-      this.uriTextBox.Location = new System.Drawing.Point(94, 3);
-      this.uriTextBox.Name = "uriTextBox";
-      this.uriTextBox.Size = new System.Drawing.Size(205, 20);
-      this.uriTextBox.TabIndex = 0;
+      this.viewComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.viewComboBox.FormattingEnabled = true;
+      this.viewComboBox.Location = new System.Drawing.Point(3, 3);
+      this.viewComboBox.Name = "viewComboBox";
+      this.viewComboBox.Size = new System.Drawing.Size(121, 21);
+      this.viewComboBox.TabIndex = 7;
       // 
-      // uriLabel
+      // resultsButton
       // 
-      this.uriLabel.AutoSize = true;
-      this.uriLabel.Location = new System.Drawing.Point(6, 6);
-      this.uriLabel.Name = "uriLabel";
-      this.uriLabel.Size = new System.Drawing.Size(82, 13);
-      this.uriLabel.TabIndex = 1;
-      this.uriLabel.Text = "CEDMA Server:";
-      // 
-      // connectButton
-      // 
-      this.connectButton.Location = new System.Drawing.Point(305, 1);
-      this.connectButton.Name = "connectButton";
-      this.connectButton.Size = new System.Drawing.Size(75, 23);
-      this.connectButton.TabIndex = 3;
-      this.connectButton.Text = "&Connect";
-      this.connectButton.UseVisualStyleBackColor = true;
-      this.connectButton.Click += new System.EventHandler(this.connectButton_Click);
-      // 
-      // serverPanel
-      // 
-      this.serverPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.serverPanel.Location = new System.Drawing.Point(3, 29);
-      this.serverPanel.Name = "serverPanel";
-      this.serverPanel.Size = new System.Drawing.Size(439, 157);
-      this.serverPanel.TabIndex = 4;
+      this.resultsButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.resultsButton.Location = new System.Drawing.Point(130, 1);
+      this.resultsButton.Name = "resultsButton";
+      this.resultsButton.Size = new System.Drawing.Size(86, 23);
+      this.resultsButton.TabIndex = 6;
+      this.resultsButton.Text = "Show results";
+      this.resultsButton.UseVisualStyleBackColor = true;
+      this.resultsButton.Click += new System.EventHandler(this.resultsButton_Click);
       // 
       // ConsoleEditor
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.Controls.Add(this.serverPanel);
-      this.Controls.Add(this.connectButton);
-      this.Controls.Add(this.uriLabel);
-      this.Controls.Add(this.uriTextBox);
+      this.Controls.Add(this.viewComboBox);
+      this.Controls.Add(this.resultsButton);
       this.Name = "ConsoleEditor";
       this.Size = new System.Drawing.Size(445, 189);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
@@ -104,16 +81,16 @@
     #endregion
 
-    private void connectButton_Click(object sender, EventArgs e) {
-      try {
-        console.Connect(uriTextBox.Text);
-        connectButton.Enabled = false;
-        serverPanel.Enabled = true;
-        serverPanel.Controls.Clear();
-        Control dataSetView = (Control)console.DataSet.CreateView();
-        dataSetView.Dock = DockStyle.Fill;
-        serverPanel.Controls.Add(dataSetView);
-      } catch(CommunicationException ex) {
-        MessageBox.Show("Exception while trying to connect to " + uriTextBox.Text + "\n" + ex.Message);
-      }
+    private void PopulateViewComboBox() {
+      DiscoveryService service = new DiscoveryService();
+      IResultsViewFactory[] factories = service.GetInstances<IResultsViewFactory>();
+      viewComboBox.DataSource = factories;
+      viewComboBox.ValueMember = "Name";
+    }
+
+
+    private void resultsButton_Click(object sender, EventArgs e) {
+      IResultsViewFactory factory = (IResultsViewFactory)viewComboBox.SelectedItem;
+      IControl control = factory.CreateView(console.Results);
+      PluginManager.ControlManager.ShowControl(control);
     }
   }
Index: trunk/sources/HeuristicLab.CEDMA.Core/3.3/HeuristicLab.CEDMA.Core-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/3.3/HeuristicLab.CEDMA.Core-3.3.csproj	(revision 2146)
+++ trunk/sources/HeuristicLab.CEDMA.Core/3.3/HeuristicLab.CEDMA.Core-3.3.csproj	(revision 2223)
@@ -88,5 +88,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="StoreProxy.cs" />
     <Compile Include="IResultsViewFactory.cs" />
     <Compile Include="ResultsEntry.cs" />
@@ -101,19 +100,5 @@
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="Problem.cs" />
-    <Compile Include="DataSet.cs" />
-    <Compile Include="DataSetView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="DataSetView.Designer.cs">
-      <DependentUpon>DataSetView.cs</DependentUpon>
-    </Compile>
     <Compile Include="HeuristicLabCedmaCorePlugin.cs" />
-    <Compile Include="ProblemView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ProblemView.Designer.cs">
-      <DependentUpon>ProblemView.cs</DependentUpon>
-    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Results.cs" />
@@ -123,8 +108,4 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.CEDMA.DB.Interfaces\3.3\HeuristicLab.CEDMA.DB.Interfaces-3.3.csproj">
-      <Project>{4F9BB789-D561-436B-B226-2BF44B7D0804}</Project>
-      <Name>HeuristicLab.CEDMA.DB.Interfaces-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.2\HeuristicLab.Core-3.2.csproj">
       <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
@@ -138,4 +119,12 @@
       <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
       <Name>HeuristicLab.Data-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Modeling.Database.SQLServerCompact\3.2\HeuristicLab.Modeling.Database.SQLServerCompact-3.2.csproj">
+      <Project>{EC1AA756-D612-4FA6-AA52-25CF4F8E3836}</Project>
+      <Name>HeuristicLab.Modeling.Database.SQLServerCompact-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Modeling.Database\3.2\HeuristicLab.Modeling.Database-3.2.csproj">
+      <Project>{E84E5717-79F8-498F-A5E0-A055C4EC086B}</Project>
+      <Name>HeuristicLab.Modeling.Database-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Operators\3.2\HeuristicLab.Operators-3.2.csproj">
@@ -155,10 +144,4 @@
       <DependentUpon>ConsoleEditor.cs</DependentUpon>
       <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="DataSetView.resx">
-      <DependentUpon>DataSetView.cs</DependentUpon>
-    </EmbeddedResource>
-    <EmbeddedResource Include="ProblemView.resx">
-      <DependentUpon>ProblemView.cs</DependentUpon>
     </EmbeddedResource>
   </ItemGroup>
Index: trunk/sources/HeuristicLab.CEDMA.Core/3.3/HeuristicLabCedmaCorePlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/3.3/HeuristicLabCedmaCorePlugin.cs	(revision 2146)
+++ trunk/sources/HeuristicLab.CEDMA.Core/3.3/HeuristicLabCedmaCorePlugin.cs	(revision 2223)
@@ -31,6 +31,7 @@
   [Dependency(Dependency = "HeuristicLab.Data-3.2")]
   [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.CEDMA.DB.Interfaces-3.3")]
   [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Modeling.Database-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Modeling.Database.SQLServerCompact-3.2")]
   public class HeuristicLabCedmaCorePlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.CEDMA.Core/3.3/IResultsViewFactory.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/3.3/IResultsViewFactory.cs	(revision 2146)
+++ trunk/sources/HeuristicLab.CEDMA.Core/3.3/IResultsViewFactory.cs	(revision 2223)
@@ -26,5 +26,4 @@
 using HeuristicLab.Core;
 using System.Xml;
-using HeuristicLab.CEDMA.DB.Interfaces;
 using HeuristicLab.Operators;
 using System.Windows.Forms;
Index: trunk/sources/HeuristicLab.CEDMA.Core/3.3/Results.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/3.3/Results.cs	(revision 2146)
+++ trunk/sources/HeuristicLab.CEDMA.Core/3.3/Results.cs	(revision 2223)
@@ -26,5 +26,4 @@
 using HeuristicLab.Core;
 using System.Collections;
-using HeuristicLab.CEDMA.DB.Interfaces;
 using System.Xml;
 using System.Runtime.Serialization;
@@ -34,8 +33,8 @@
 using HeuristicLab.DataAnalysis;
 using System.Drawing;
+using HeuristicLab.Modeling.Database;
 
 namespace HeuristicLab.CEDMA.Core {
   public class Results : ItemBase {
-    private const int PAGE_SIZE = 1000;
     private string[] categoricalVariables = null;
     public string[] CategoricalVariables {
@@ -58,5 +57,5 @@
     }
 
-    private string[] multiDimensionalOrdinalVariables = new string[] { "VariableImpacts: EvaluationImpact", "VariableImpacts: QualityImpact" };
+    private string[] multiDimensionalOrdinalVariables;
     public string[] MultiDimensionalOrdinalVariables {
       get { return multiDimensionalOrdinalVariables; }
@@ -68,16 +67,11 @@
     }
 
-    private IStore store;
-    public IStore Store {
-      get { return store; }
-      set {
-        store = value;
-      }
-    }
+    private IModelingDatabase database;
 
     private Dictionary<string, Dictionary<object, double>> categoricalValueIndices = new Dictionary<string, Dictionary<object, double>>();
 
-    public Results(IStore store) {
-      this.store = store;
+    public Results(IModelingDatabase database) {
+      this.database = database;
+      multiDimensionalOrdinalVariables = database.GetAllResultsForInputVariables().Select(x => "VariableImpacts: " + x.Name).ToArray();
     }
 
@@ -91,101 +85,30 @@
 
     private IEnumerable<ResultsEntry> SelectRows() {
-      int page = 0;
-      int resultsReturned = 0;
+      database.Connect();      
       entries = new List<ResultsEntry>();
-      if (store == null) return entries;
-      do {
-        var allModels = store.Query(
-          "?Model <" + Ontology.InstanceOf + "> <" + Ontology.TypeModel + "> ." +
-          "?Model <" + Ontology.TargetVariable + "> ?TargetVariable ." +
-          "?Model <" + Ontology.TestMeanSquaredError + "> ?TestMSE .",
-          0, 3000)
-          .Select(modelBinding => new {
-            Model = ((Entity)modelBinding.Get("Model")).Uri,
-            TestMSE = (double)((Literal)modelBinding.Get("TestMSE")).Value,
-            TargetVariable = (string)((Literal)modelBinding.Get("TargetVariable")).Value
-          })
-          .Distinct()
-          .GroupBy(m => m.TargetVariable)
-          .Select(grouping => grouping.OrderBy(m => m.TestMSE));
-        foreach (var targetVariableBindings in allModels) {
-          resultsReturned = targetVariableBindings.Count();
-          int nModels = Math.Max(10, resultsReturned * 10 / 100);
-          nModels = Math.Min(nModels, resultsReturned);
-          foreach (var modelBindings in targetVariableBindings.Take(nModels)) {
-            ResultsEntry entry = new ResultsEntry();
-            entry.Uri = modelBindings.Model;
-            entries.Add(entry);
-            SetModelAttributes(entry, modelBindings.Model);
-            entry.Set("VariableImpacts", SelectVariableImpacts(modelBindings.Model));
+      foreach (var model in database.GetAllModels()) {
+        ResultsEntry modelEntry = new ResultsEntry();
+        foreach (var modelResult in database.GetModelResults(model)) {
+          modelEntry.Set(modelResult.Result.Name, modelResult.Value);
+        }
+        modelEntry.Set("PersistedData", database.GetModelData(model));
+        modelEntry.Set("TargetVariable", model.TargetVariable.Name);
+        Dictionary<HeuristicLab.Modeling.Database.IVariable, ResultsEntry> inputVariableResultsEntries =
+          new Dictionary<HeuristicLab.Modeling.Database.IVariable, ResultsEntry>();
+
+        foreach (IInputVariableResult inputVariableResult in database.GetInputVariableResults(model)) {
+          if (!inputVariableResultsEntries.ContainsKey(inputVariableResult.Variable)) {
+            inputVariableResultsEntries[inputVariableResult.Variable] = new ResultsEntry();
+            inputVariableResultsEntries[inputVariableResult.Variable].Set("InputVariableName", inputVariableResult.Variable.Name);
           }
+          inputVariableResultsEntries[inputVariableResult.Variable].Set(inputVariableResult.Result.Name, inputVariableResult.Value);
         }
-        page++;
-      } while (resultsReturned == PAGE_SIZE);
+        modelEntry.Set("VariableImpacts", inputVariableResultsEntries.Values);
+        entries.Add(modelEntry);
+      }
+      database.Disconnect();
       FireChanged();
       cached = true;
       return entries;
-    }
-
-    private void SetModelAttributes(ResultsEntry entry, string modelUri) {
-      var modelBindings = store.Query(
-        "<" + modelUri + "> ?Attribute ?Value .",
-        0, PAGE_SIZE);
-      foreach (var binding in modelBindings) {
-        if (binding.Get("Value") is Literal) {
-          string name = ((Entity)binding.Get("Attribute")).Uri.Replace(Ontology.CedmaNameSpace, "");
-          if (entry.Get(name) == null) {
-            object value = ((Literal)binding.Get("Value")).Value;
-            entry.Set(name, value);
-          }
-        }
-      }
-    }
-
-    private IEnumerable<ResultsEntry> SelectVariableImpacts(string modelUri) {
-      var inputVariableNameBindings = store.Query(
-          "<" + modelUri + "> <" + Ontology.HasInputVariable + "> ?InputVariable ." +
-          "?InputVariable <" + Ontology.Name + "> ?InputName .",
-          0, PAGE_SIZE);
-
-      var qualityImpactBindings = store.Query(
-          "<" + modelUri + "> <" + Ontology.HasInputVariable + "> ?InputVariable ." +
-          "?InputVariable <" + Ontology.QualityImpact + "> ?QualityImpact .",
-          0, PAGE_SIZE);
-
-      var evaluationImpactBindings = store.Query(
-           "<" + modelUri + "> <" + Ontology.HasInputVariable + "> ?InputVariable ." +
-           "?InputVariable <" + Ontology.EvaluationImpact + "> ?EvaluationImpact .",
-           0, PAGE_SIZE);
-      Dictionary<object, ResultsEntry> inputVariableAttributes = new Dictionary<object, ResultsEntry>();
-
-      foreach (var inputVariableNameBinding in inputVariableNameBindings) {
-        object inputVariable = inputVariableNameBinding.Get("InputVariable");
-        object name = ((Literal)inputVariableNameBinding.Get("InputName")).Value;
-        if (!inputVariableAttributes.ContainsKey(inputVariable)) {
-          inputVariableAttributes[inputVariable] = new ResultsEntry();
-          inputVariableAttributes[inputVariable].Set("InputVariableName", name);
-        }
-      }
-
-      foreach (var qualityImpactBinding in qualityImpactBindings) {
-        double qualityImpact = (double)((Literal)qualityImpactBinding.Get("QualityImpact")).Value;
-        object inputVariable = qualityImpactBinding.Get("InputVariable");
-        if (!IsAlmost(qualityImpact, 1.0)) {
-          if (inputVariableAttributes[inputVariable].Get("QualityImpact") == null)
-            inputVariableAttributes[inputVariable].Set("QualityImpact", qualityImpact);
-        } else inputVariableAttributes.Remove(inputVariable);
-      }
-
-      foreach (var evaluationImpactBinding in evaluationImpactBindings) {
-        double evaluationImpact = (double)((Literal)evaluationImpactBinding.Get("EvaluationImpact")).Value;
-        object inputVariable = evaluationImpactBinding.Get("InputVariable");
-        if (!IsAlmost(evaluationImpact, 0.0)) {
-          if (inputVariableAttributes.ContainsKey(inputVariable) && inputVariableAttributes[inputVariable].Get("EvaluationImpact") == null)
-            inputVariableAttributes[inputVariable].Set("EvaluationImpact", evaluationImpact);
-        } else inputVariableAttributes.Remove(inputVariable);
-      }
-
-      return inputVariableAttributes.Values;
     }
 
@@ -199,20 +122,6 @@
 
     private void LoadModelAttributes() {
-      this.ordinalVariables =
-        store
-          .Query(
-            "?ModelAttribute <" + Ontology.InstanceOf + "> <" + Ontology.TypeModelAttribute + "> ." + Environment.NewLine +
-            "?ModelAttribute <" + Ontology.InstanceOf + "> <" + Ontology.TypeOrdinalAttribute + "> .", 0, 100)
-          .Select(s => ((Entity)s.Get("ModelAttribute")).Uri.Replace(Ontology.CedmaNameSpace, ""))
-          .Distinct()
-          .ToArray();
-      this.categoricalVariables =
-        store
-          .Query(
-            "?ModelAttribute <" + Ontology.InstanceOf + "> <" + Ontology.TypeModelAttribute + "> ." + Environment.NewLine +
-            "?ModelAttribute <" + Ontology.InstanceOf + "> <" + Ontology.TypeCategoricalAttribute + "> .", 0, 100)
-          .Select(s => ((Entity)s.Get("ModelAttribute")).Uri.Replace(Ontology.CedmaNameSpace, ""))
-          .Distinct()
-          .ToArray();
+      ordinalVariables = database.GetAllResults().Select(r => r.Name).ToArray();
+      categoricalVariables = new string[] { "TargetVariable" };
     }
 
Index: trunk/sources/HeuristicLab.CEDMA.Core/3.3/ResultsEntry.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/3.3/ResultsEntry.cs	(revision 2146)
+++ trunk/sources/HeuristicLab.CEDMA.Core/3.3/ResultsEntry.cs	(revision 2223)
@@ -26,5 +26,4 @@
 using HeuristicLab.Core;
 using System.Collections;
-using HeuristicLab.CEDMA.DB.Interfaces;
 using System.Xml;
 using System.Runtime.Serialization;
Index: trunk/sources/HeuristicLab.CEDMA.Core/3.3/TableResultsView.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/3.3/TableResultsView.cs	(revision 2146)
+++ trunk/sources/HeuristicLab.CEDMA.Core/3.3/TableResultsView.cs	(revision 2223)
@@ -10,5 +10,4 @@
 using HeuristicLab.CEDMA.Core;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.CEDMA.DB.Interfaces;
 
 namespace HeuristicLab.CEDMA.Core {
@@ -69,7 +68,6 @@
       if (e.Button == MouseButtons.Left && e.Clicks == 2) {
         DataGridView.HitTestInfo hitInfo = dataGridView.HitTest(e.X, e.Y);
-        ResultsEntry entry = (ResultsEntry)dataGridView.Rows[hitInfo.RowIndex].Tag;
-        string serializedData =  (string)entry.Get(Ontology.SerializedData.Uri.Replace(Ontology.CedmaNameSpace, ""));
-        var model = (IItem)PersistenceManager.RestoreFromGZip(Convert.FromBase64String(serializedData));
+        ResultsEntry entry = (ResultsEntry)dataGridView.Rows[hitInfo.RowIndex].Tag;        
+        var model = (IItem)PersistenceManager.RestoreFromGZip((byte[])entry.Get("PersistedData"));
         PluginManager.ControlManager.ShowControl(model.CreateView());
       }